---
title: Web Audio API
slug: Web/API/Web_Audio_API
tags:
  - API
  - Audio
  - Example
  - Landing
  - Overview
  - Web Audio API
  - sound
---
<div>{{DefaultAPISidebar("Web Audio API")}}</div>

<p class="summary">The Web Audio API provides a powerful and versatile system for controlling audio on the Web, allowing developers to choose audio sources, add effects to audio, create audio visualizations, apply spatial effects (such as panning) and much more.</p>

<h2 id="Web_audio_concepts_and_usage">Web audio concepts and usage</h2>

<p>The Web Audio API involves handling audio operations inside an <strong>audio context</strong>, and has been designed to allow <strong>modular routing</strong>. Basic audio operations are performed with <strong>audio nodes</strong>, which are linked together to form an <strong>audio routing graph</strong>. Several sources — with different types of channel layout — are supported even within a single context. This modular design provides the flexibility to create complex audio functions with dynamic effects.</p>

<p>Audio nodes are linked into chains and simple webs by their inputs and outputs. They typically start with one or more sources. Sources provide arrays of sound intensities (samples) at very small timeslices, often tens of thousands of them per second. These could be either computed mathematically (such as {{domxref("OscillatorNode")}}), or they can be recordings from sound/video files (like {{domxref("AudioBufferSourceNode")}} and {{domxref("MediaElementAudioSourceNode")}}) and audio streams ({{domxref("MediaStreamAudioSourceNode")}}). In fact, sound files are just recordings of sound intensities themselves, which come in from microphones or electric instruments, and get mixed down into a single, complicated wave.</p>

<p>Outputs of these nodes could be linked to inputs of others, which mix or modify these streams of sound samples into different streams. A common modification is multiplying the samples by a value to make them louder or quieter (as is the case with {{domxref("GainNode")}}). Once the sound has been sufficiently processed for the intended effect, it can be linked to the input of a destination ({{domxref("AudioContext.destination")}}), which sends the sound to the speakers or headphones. This last connection is only necessary if the user is supposed to hear the audio.</p>

<p>A simple, typical workflow for web audio would look something like this:</p>

<ol>
	<li>Create audio context</li>
	<li>Inside the context, create sources — such as <code>&lt;audio&gt;</code>, oscillator, stream</li>
	<li>Create effects nodes, such as reverb, biquad filter, panner, compressor</li>
	<li>Choose final destination of audio, for example your system speakers</li>
	<li>Connect the sources up to the effects, and the effects to the destination.</li>
</ol>

<p><img alt="A simple box diagram with an outer box labeled Audio context, and three inner boxes labeled Sources, Effects and Destination. The three inner boxes have arrow between them pointing from left to right, indicating the flow of audio information." src="https://mdn.mozillademos.org/files/16043/audio-context_.png" style="height: 400px; width: 1200px;"></p>

<p>Timing is controlled with high precision and low latency, allowing developers to write code that responds accurately to events and is able to target specific samples, even at a high sample rate. So applications such as drum machines and sequencers are well within reach.</p>

<p>The Web Audio API also allows us to control how audio is <em>spatialized</em>. Using a system based on a <em>source-listener model</em>, it allows control of the <em>panning model</em> and deals with <em>distance-induced attenuation</em> induced by a moving source (or moving listener).</p>

<div class="note">
<p>You can read about the theory of the Web Audio API in a lot more detail in our article <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API">Basic concepts behind Web Audio API</a>.</p>
</div>

<h2 id="Web_Audio_API_target_audience">Web Audio API target audience</h2>

<p>The Web Audio API can seem intimidating to those that aren't familiar with audio or music terms, and as it incorporates a great deal of functionality it can prove difficult to get started if you are a developer.</p>

<p>It can be used to incorporate audio into your website or application, by <a href="https://www.futurelibrary.no/">providing atmosphere like futurelibrary.no</a>, or <a href="https://css-tricks.com/form-validation-web-audio/">auditory feedback on forms</a>. However, it can also be used to create <em>advanced</em> interactive instruments. With that in mind, it is suitable for both developers and musicians alike.</p>

<p>We have a <a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">simple introductory tutorial</a> for those that are familiar with programming but need a good introduction to some of the terms and structure of the API.</p>

<p>There's also a <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API">Basic Concepts Behind Web Audio API</a> article, to help you understand the way digital audio works, specifically in the realm of the API. This also includes a good introduction to some of the concepts the API is built upon.</p>

<p>Learning coding is like playing cards — you learn the rules, then you play, then you go back and learn the rules again, then you play again. So if some of the theory doesn't quite fit after the first tutorial and article, there's an <a href="/en-US/docs/Web/API/Web_Audio_API/Advanced_techniques">advanced tutorial</a> which extends the first one to help you practise what you've learnt, and apply some more advanced techniques to build up a step sequencer.</p>

<p>We also have other tutorials and comprehensive reference material available that covers all features of the API. See the sidebar on this page for more.</p>

<p>If you are more familiar with the musical side of things, are familiar with music theory concepts, want to start building instruments, then you can go ahead and start building things with the advance tutorial and others as a guide (the above linked tutorial covers scheduling notes, creating bespoke oscillators and envelopes, as well as an LFO among other things.)</p>

<p>If you aren't familiar with the programming basics, you might want to consult some beginner's JavaScript tutorials first and then come back here — see our <a href="/en-US/docs/Learn/JavaScript">Beginner's JavaScript learning module</a> for a great place to begin.</p>

<h2 id="Web_Audio_API_interfaces">Web Audio API interfaces</h2>

<p>The Web Audio API has a number of interfaces and associated events, which we have split up into nine categories of functionality.</p>

<h3 id="General_audio_graph_definition">General audio graph definition</h3>

<p>General containers and definitions that shape audio graphs in Web Audio API usage.</p>

<dl>
	<dt>{{domxref("AudioContext")}}</dt>
	<dd>The <strong><code>AudioContext</code></strong> interface represents an audio-processing graph built from audio modules linked together, each represented by an {{domxref("AudioNode")}}. An audio context controls the creation of the nodes it contains and the execution of the audio processing, or decoding. You need to create an <code>AudioContext</code> before you do anything else, as everything happens inside a context.</dd>
	<dt>{{domxref("AudioContextOptions")}}</dt>
	<dd>The <code><strong>AudioContextOptions</strong></code> dictionary is used to provide options when instantiating a new <code>AudioContext</code>.</dd>
	<dt>{{domxref("AudioNode")}}</dt>
	<dd>The <strong><code>AudioNode</code></strong><strong> </strong>interface represents an audio-processing module like an <em>audio source</em> (e.g. an HTML {{HTMLElement("audio")}} or {{HTMLElement("video")}} element), <em>audio destination</em>, <em>intermediate processing module</em> (e.g. a filter like {{domxref("BiquadFilterNode")}}, or <em>volume control</em> like {{domxref("GainNode")}}).</dd>
	<dt>{{domxref("AudioParam")}}</dt>
	<dd>The <strong><code>AudioParam</code></strong><strong> </strong>interface represents an audio-related parameter, like one of an {{domxref("AudioNode")}}. It can be set to a specific value or a change in value, and can be scheduled to happen at a specific time and following a specific pattern.</dd>
	<dt>{{domxref("AudioParamMap")}}</dt>
	<dd>Provides a maplike interface to a group of {{domxref("AudioParam")}} interfaces, which means it provides the methods <code>forEach()</code>, <code>get()</code>, <code>has()</code>, <code>keys()</code>, and <code>values()</code>, as well as a <code>size</code> property.</dd>
	<dt>{{domxref("BaseAudioContext")}}</dt>
	<dd>The <strong><code>BaseAudioContext</code></strong> interface acts as a base definition for online and offline audio-processing graphs, as represented by {{domxref("AudioContext")}} and {{domxref("OfflineAudioContext")}} respectively. You wouldn't use <code>BaseAudioContext</code> directly — you'd use its features via one of these two inheriting interfaces.</dd>
	<dt>The {{event("ended")}} event</dt>
	<dd>The <code>ended</code> event is fired when playback has stopped because the end of the media was reached.</dd>
</dl>

<h3 id="Defining_audio_sources">Defining audio sources</h3>

<p>Interfaces that define audio sources for use in the Web Audio API.</p>

<dl>
	<dt>{{domxref("AudioScheduledSourceNode")}}</dt>
	<dd>The <strong><code>AudioScheduledSourceNode</code></strong> is a parent interface for several types of audio source node interfaces. It is an {{domxref("AudioNode")}}.</dd>
</dl>

<dl>
	<dt>{{domxref("OscillatorNode")}}</dt>
	<dd>The <strong><code style="font-size: 14px;">OscillatorNode</code></strong><strong> </strong>interface represents a periodic waveform, such as a sine or triangle wave. It is an {{domxref("AudioNode")}} audio-processing module that causes a given <em>frequency</em> of wave to be created.</dd>
	<dt>{{domxref("AudioBuffer")}}</dt>
	<dd>The <strong><code>AudioBuffer</code></strong> interface represents a short audio asset residing in memory, created from an audio file using the {{ domxref("AudioContext.decodeAudioData()") }} method, or created with raw data using {{ domxref("AudioContext.createBuffer()") }}. Once decoded into this form, the audio can then be put into an {{ domxref("AudioBufferSourceNode") }}.</dd>
	<dt>{{domxref("AudioBufferSourceNode")}}</dt>
	<dd>The <strong><code>AudioBufferSourceNode</code></strong> interface represents an audio source consisting of in-memory audio data, stored in an {{domxref("AudioBuffer")}}. It is an {{domxref("AudioNode")}} that acts as an audio source.</dd>
	<dt>{{domxref("MediaElementAudioSourceNode")}}</dt>
	<dd>The <code><strong>MediaElementAudioSourceNode</strong></code> interface represents an audio source consisting of an HTML5 {{ htmlelement("audio") }} or {{ htmlelement("video") }} element. It is an {{domxref("AudioNode")}} that acts as an audio source.</dd>
	<dt>{{domxref("MediaStreamAudioSourceNode")}}</dt>
	<dd>The <code><strong>MediaStreamAudioSourceNode</strong></code> interface represents an audio source consisting of a {{domxref("MediaStream")}} (such as a webcam, microphone, or a stream being sent from a remote computer). If multiple audio tracks are present on the stream, the track whose {{domxref("MediaStreamTrack.id", "id")}} comes first lexicographically (alphabetically) is used. It is an {{domxref("AudioNode")}} that acts as an audio source.</dd>
	<dt>{{domxref("MediaStreamTrackAudioSourceNode")}}</dt>
	<dd>A node of type {{domxref("MediaStreamTrackAudioSourceNode")}} represents an audio source whose data comes from a {{domxref("MediaStreamTrack")}}. When creating the node using the {{domxref("AudioContext.createMediaStreamTrackSource", "createMediaStreamTrackSource()")}} method to create the node, you specify which track to use. This provides more control than <code>MediaStreamAudioSourceNode</code>.</dd>
</dl>

<h3 id="Defining_audio_effects_filters">Defining audio effects filters</h3>

<p>Interfaces for defining effects that you want to apply to your audio sources.</p>

<dl>
	<dt>{{domxref("BiquadFilterNode")}}</dt>
	<dd>The <strong><code>BiquadFilterNode</code></strong><strong> </strong>interface represents a simple low-order filter. It is an {{domxref("AudioNode")}} that can represent different kinds of filters, tone control devices, or graphic equalizers. A <code>BiquadFilterNode</code> always has exactly one input and one output.</dd>
	<dt>{{domxref("ConvolverNode")}}</dt>
	<dd>The <code><strong>Convolver</strong></code><strong><code>Node</code></strong><strong> </strong>interface is an <span style="line-height: 1.5;">{{domxref("AudioNode")}} that</span><span style="line-height: 1.5;"> performs a Linear Convolution on a given {{domxref("AudioBuffer")}}, and is often used to achieve a reverb effect</span><span style="line-height: 1.5;">.</span></dd>
	<dt>{{domxref("DelayNode")}}</dt>
	<dd>The <strong><code>DelayNode</code></strong><strong> </strong>interface represents a <a href="http://en.wikipedia.org/wiki/Digital_delay_line">delay-line</a>; an {{domxref("AudioNode")}} audio-processing module that causes a delay between the arrival of an input data and its propagation to the output.</dd>
	<dt>{{domxref("DynamicsCompressorNode")}}</dt>
	<dd>The <strong><code>DynamicsCompressorNode</code></strong> interface provides a compression effect, which lowers the volume of the loudest parts of the signal in order to help prevent clipping and distortion that can occur when multiple sounds are played and multiplexed together at once.</dd>
	<dt>{{domxref("GainNode")}}</dt>
	<dd>The <strong><code>GainNode</code></strong><strong> </strong>interface represents a change in volume. It is an {{domxref("AudioNode")}} audio-processing module that causes a given <em>gain</em> to be applied to the input data before its propagation to the output.</dd>
	<dt>{{domxref("WaveShaperNode")}}</dt>
	<dd>The <strong><code>WaveShaperNode</code></strong><strong> </strong>interface represents a non-linear distorter. It is an {{domxref("AudioNode")}} that use a curve to apply a waveshaping distortion to the signal. Beside obvious distortion effects, it is often used to add a warm feeling to the signal.</dd>
	<dt>{{domxref("PeriodicWave")}}</dt>
	<dd>Describes a periodic waveform that can be used to shape the output of an {{ domxref("OscillatorNode") }}.</dd>
	<dt>{{domxref("IIRFilterNode")}}</dt>
	<dd>Implements a general <strong><a class="external external-icon" href="https://en.wikipedia.org/wiki/infinite%20impulse%20response" title="infinite impulse response">infinite impulse response</a></strong> (IIR)  filter; this type of filter can be used to implement tone control devices and graphic equalizers as well.</dd>
</dl>

<h3 id="Defining_audio_destinations">Defining audio destinations</h3>

<p>Once you are done processing your audio, these interfaces define where to output it.</p>

<dl>
	<dt>{{domxref("AudioDestinationNode")}}</dt>
	<dd>The <strong><code>AudioDestinationNode</code></strong> interface represents the end destination of an audio source in a given context — usually the speakers of your device.</dd>
	<dt>{{domxref("MediaStreamAudioDestinationNode")}}</dt>
	<dd>The <code><strong>MediaStreamAudio</strong></code><strong><code>DestinationNode</code></strong> interface represents an audio destination consisting of a <a href="/en-US/docs/WebRTC">WebRTC</a> {{domxref("MediaStream")}} with a single <code>AudioMediaStreamTrack</code>, which can be used in a similar way to a {{domxref("MediaStream")}} obtained from {{ domxref("MediaDevices.getUserMedia", "getUserMedia()") }}. It is an {{domxref("AudioNode")}} that acts as an audio destination.</dd>
</dl>

<h3 id="Data_analysis_and_visualization">Data analysis and visualization</h3>

<p>If you want to extract time, frequency, and other data from your audio, the <code>AnalyserNode</code> is what you need.</p>

<dl>
	<dt>{{domxref("AnalyserNode")}}</dt>
	<dd>The <strong><code>AnalyserNode</code></strong> interface represents a node able to provide real-time frequency and time-domain analysis information, for the purposes of data analysis and visualization.</dd>
</dl>

<h3 id="Splitting_and_merging_audio_channels">Splitting and merging audio channels</h3>

<p>To split and merge audio channels, you'll use these interfaces.</p>

<dl>
	<dt>{{domxref("ChannelSplitterNode")}}</dt>
	<dd>The <code><strong>ChannelSplitterNode</strong></code> interface separates the different channels of an audio source out into a set of <em>mono</em> outputs.</dd>
	<dt>{{domxref("ChannelMergerNode")}}</dt>
	<dd>The <code><strong>ChannelMergerNode</strong></code> interface reunites different mono inputs into a single output. Each input will be used to fill a channel of the output.</dd>
</dl>

<h3 id="Audio_spatialization">Audio spatialization</h3>

<p>These interfaces allow you to add audio spatialization panning effects to your audio sources.</p>

<dl>
	<dt>{{domxref("AudioListener")}}</dt>
	<dd>The <strong><code>AudioListener</code></strong><strong> </strong>interface represents the position and orientation of the unique person listening to the audio scene used in audio spatialization.</dd>
	<dt>{{domxref("PannerNode")}}</dt>
	<dd>The <code><strong>PannerNode</strong></code> interface represents the position and behavior of an audio source signal in 3D space, allowing you to create complex panning effects.</dd>
	<dt>{{domxref("StereoPannerNode")}}</dt>
	<dd>The <code><strong>StereoPannerNode</strong></code> interface represents a simple stereo panner node that can be used to pan an audio stream left or right.</dd>
</dl>

<h3 id="Audio_processing_in_JavaScript">Audio processing in JavaScript</h3>

<p>Using audio worklets, you can define custom audio nodes written in JavaScript or <a href="/en-US/docs/WebAssembly">WebAssembly</a>. Audio worklets implement the {{domxref("Worklet")}} interface, a lightweight version of the {{domxref("Worker")}} interface.</p>

<dl>
	<dt>{{domxref("AudioWorklet")}}</dt>
	<dd>The <code>AudioWorklet</code> interface is available through the {{domxref("AudioContext")}} object's {{domxref("BaseAudioContext.audioWorklet", "audioWorklet")}}, and lets you add modules to the audio worklet to be executed off the main thread.</dd>
	<dt>{{domxref("AudioWorkletNode")}}</dt>
	<dd>The <code>AudioWorkletNode</code> interface represents an {{domxref("AudioNode")}} that is embedded into an audio graph and can pass messages to the corresponding <code>AudioWorkletProcessor</code>.</dd>
	<dt>{{domxref("AudioWorkletProcessor")}}</dt>
	<dd>The <code>AudioWorkletProcessor</code> interface represents audio processing code running in a <code>AudioWorkletGlobalScope</code> that generates, processes, or analyses audio directly, and can pass messages to the corresponding <code>AudioWorkletNode</code>.</dd>
	<dt>{{domxref("AudioWorkletGlobalScope")}}</dt>
	<dd>The <code>AudioWorkletGlobalScope</code> interface is a <code>WorkletGlobalScope</code>-derived object representing a worker context in which an audio processing script is run; it is designed to enable the generation, processing, and analysis of audio data directly using JavaScript in a worklet thread rather than on the main thread.</dd>
</dl>

<h4 id="Obsolete_script_processor_nodes">Obsolete: script processor nodes</h4>

<p>Before audio worklets were defined, the Web Audio API used the <code>ScriptProcessorNode</code>  for JavaScript-based audio processing. Because the code runs in the main thread, they have bad performance. The <code>ScriptProcessorNode</code> is kept for historic reasons but is marked as deprecated.</p>

<dl>
	<dt>{{domxref("ScriptProcessorNode")}} {{deprecated_inline}}</dt>
	<dd>The <strong><code>ScriptProcessorNode</code></strong><strong> </strong>interface allows the generation, processing, or analyzing of audio using JavaScript. It is an {{domxref("AudioNode")}} audio-processing module that is linked to two buffers, one containing the current input, one containing the output. An event, implementing the {{domxref("AudioProcessingEvent")}} interface, is sent to the object each time the input buffer contains new data, and the event handler terminates when it has filled the output buffer with data.</dd>
	<dt>{{event("audioprocess")}} (event) {{deprecated_inline}}</dt>
	<dd>The <code>audioprocess</code> event is fired when an input buffer of a Web Audio API {{domxref("ScriptProcessorNode")}} is ready to be processed.</dd>
	<dt>{{domxref("AudioProcessingEvent")}} {{deprecated_inline}}</dt>
	<dd>The <a href="/en-US/docs/Web_Audio_API">Web Audio API</a> <code>AudioProcessingEvent</code> represents events that occur when a {{domxref("ScriptProcessorNode")}} input buffer is ready to be processed.</dd>
</dl>

<h3 id="Offlinebackground_audio_processing">Offline/background audio processing</h3>

<p>It is possible to process/render an audio graph very quickly in the background — rendering it to an {{domxref("AudioBuffer")}} rather than to the device's speakers — with the following.</p>

<dl>
	<dt>{{domxref("OfflineAudioContext")}}</dt>
	<dd>The <strong><code>OfflineAudioContext</code></strong> interface is an {{domxref("AudioContext")}} interface representing an audio-processing graph built from linked together {{domxref("AudioNode")}}s. In contrast with a standard <code>AudioContext</code>, an <code>OfflineAudioContext</code> doesn't really render the audio but rather generates it, <em>as fast as it can</em>, in a buffer.</dd>
	<dt>{{event("complete")}} (event)</dt>
	<dd>The <code>complete</code> event is fired when the rendering of an {{domxref("OfflineAudioContext")}} is terminated.</dd>
	<dt>{{domxref("OfflineAudioCompletionEvent")}}</dt>
	<dd>The <code>OfflineAudioCompletionEvent</code> represents events that occur when the processing of an {{domxref("OfflineAudioContext")}} is terminated. The {{event("complete")}} event implements this interface.</dd>
</dl>

<h2 id="Example">Obsolete interfaces</h2>

<p>The following interfaces were defined in old versions of the Web Audio API spec, but are now obsolete and have been replaced by other interfaces.</p>

<dl>
	<dt>{{domxref("JavaScriptNode")}}</dt>
	<dd>Used for direct audio processing via JavaScript. This interface is obsolete, and has been replaced by {{domxref("ScriptProcessorNode")}}.</dd>
	<dt>{{domxref("WaveTableNode")}}</dt>
	<dd>Used to define a periodic waveform. This interface is obsolete, and has been replaced by {{domxref("PeriodicWave")}}.</dd>
</dl>

<h2 id="Guides_and_tutorials">Guides and tutorials</h2>

<p>{{LandingPageListSubpages}}</p>

<h2 id="Examples">Examples</h2>

<p>You can find a number of examples at our <a href="https://github.com/mdn/webaudio-examples/">webaudio-example repo</a> on GitHub.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Audio API')}}</td>
			<td>{{Spec2('Web Audio API')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<h3 id="AudioContext">AudioContext</h3>

<div>

<p>{{Compat("api.AudioContext", 0)}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<h3 id="Tutorialsguides">Tutorials/guides</h3>

<ul>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API">Basic concepts behind Web Audio API</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Advanced_techniques">Advanced techniques: creating sound, sequencing, timing, scheduling</a></li>
	<li><a href="/en-US/docs/Web/Media/Autoplay_guide">Autoplay guide for media and Web Audio APIs</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_IIR_filters">Using IIR filters</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Visualizations_with_Web_Audio_API">Visualizations with Web Audio API</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialisation_basics">Web audio spatialisation basics</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Controlling_multiple_parameters_with_ConstantSourceNode">Controlling multiple parameters with ConstantSourceNode</a></li>
	<li><a href="http://www.html5rocks.com/tutorials/webaudio/positional_audio/">Mixing Positional Audio and WebGL</a></li>
	<li><a href="http://www.html5rocks.com/tutorials/webaudio/games/">Developing Game Audio with the Web Audio API</a></li>
	<li><a href="/en-US/docs/Web/API/Web_Audio_API/Porting_webkitAudioContext_code_to_standards_based_AudioContext" title="/en-US/docs/Web_Audio_API/Porting_webkitAudioContext_code_to_standards_based_AudioContext">Porting webkitAudioContext code to standards based AudioContext</a></li>
</ul>

<h3 id="Libraries">Libraries</h3>

<ul>
	<li><a href="https://github.com/bit101/tones">Tones</a>: a simple library for playing specific tones/notes using the Web Audio API.</li>
	<li><a href="https://tonejs.github.io/">Tone.js</a>: a framework for creating interactive music in the browser.</li>
	<li><a href="https://github.com/goldfire/howler.js/">howler.js</a>: a JS audio library that defaults to <a href="https://webaudio.github.io/web-audio-api/">Web Audio API</a> and falls back to <a href="http://www.whatwg.org/specs/web-apps/current-work/#the-audio-element">HTML5 Audio</a>, as well as providing other useful features.</li>
	<li><a href="https://github.com/mattlima/mooog">Mooog</a>: jQuery-style chaining of AudioNodes, mixer-style sends/returns, and more.</li>
	<li><a href="https://korilakkuma.github.io/XSound/">XSound</a>: Web Audio API Library for Synthesizer, Effects, Visualization, Recording ... etc</li>
	<li><a class="external external-icon" href="https://github.com/chrisjohndigital/OpenLang">OpenLang</a>: HTML5 video language lab web application using the Web Audio API to record and combine video and audio from different sources into a single file (<a class="external external-icon" href="https://github.com/chrisjohndigital/OpenLang">source on GitHub</a>)</li>
	<li><a href="https://ptsjs.org/">Pts.js</a>: Simplifies web audio visualization (<a href="https://ptsjs.org/guide/sound-0800">guide</a>)</li>
</ul>

<h3 id="Related_topics">Related topics</h3>

<ul>
	<li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
	<li><a href="/en-US/docs/Web/Media/Formats">Guide to media types and formats on the web</a></li>
</ul>
